## onevpl-intel-gpu 25.1.4

=== CMakeLists.txt ===
# Copyright (c) 2017-2021 Intel Corporation
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

cmake_minimum_required( VERSION 3.14 )

cmake_policy(SET CMP0048 NEW)   # version handled by project()
if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.15)
cmake_policy(SET CMP0092 NEW)   # we handle warning level programmaticaly
endif()


# Througout this project MFX_VERSION refers to uAPI version and MEDIA_VERSION refers to product version
set(MEDIA_VERSION 25.1.4) # auto-update
set(MEDIA_VERSION_STR "${MEDIA_VERSION}${MEDIA_VERSION_EXTRA}" CACHE STRING "" FORCE)

set(LANG CXX C ASM)
project(mfxgen1
  VERSION ${MEDIA_VERSION}
  LANGUAGES ${LANG})

include(CMakeDependentOption)

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# Default to `release` build if nothing was specified
if((NOT CMAKE_BUILD_TYPE) AND (CMAKE_SYSTEM_NAME MATCHES Linux))
  message(STATUS "No build type selected, default to release")
  set(CMAKE_BUILD_TYPE release)
endif()

set( BUILDER_ROOT "${CMAKE_HOME_DIRECTORY}/builder" )

if(DEFINED API)
  message(STATUS "Ignoring specified API: $API in favor or version in mfxdefs.h")
  set( API "" )
  set( MFX_API_HOME "${MFX_HOME}/api")
endif()

if(NOT DEFINED ENV{MFX_HOME} )
  set( MFX_HOME "${CMAKE_HOME_DIRECTORY}" )
  set( MFX_API_HOME "${CMAKE_HOME_DIRECTORY}/api" )
else()
  set( MFX_HOME $ENV{MFX_HOME} )
  set( MFX_API_HOME "${MFX_HOME}/api")
endif()

include( ${BUILDER_ROOT}/FindMFX.cmake )

include( ${BUILDER_ROOT}/FindInternals.cmake )
include( ${BUILDER_ROOT}/FindOpenCL.cmake )
include( ${BUILDER_ROOT}/FindFunctions.cmake )
include( ${BUILDER_ROOT}/BuildOptions.cmake )
include( ${BUILDER_ROOT}/FindGlobals.cmake )
include( ${BUILDER_ROOT}/FindITT.cmake )
include( ${BUILDER_ROOT}/FindIPP.cmake OPTIONAL)
include( ${BUILDER_ROOT}/FindPackages.cmake )

if (MFX_ENABLE_PXP)
  add_definitions(-DMFX_ENABLE_PXP_EXT)
endif()

if (BUILD_RUNTIME)
  add_subdirectory(${CMAKE_HOME_DIRECTORY}/contrib/ipp)
  add_subdirectory(${CMAKE_HOME_DIRECTORY}/_studio)
endif()


if (ENABLE_ITT)
  target_link_libraries(mfx_common_properties INTERFACE itt)
endif()

message("")
message("********************** Intel VPL GPU Runtime Configuration Summary **********************")
message("Intel VPL:")
message("  API (request to use this version)       : ${API}")
message("  API_VERSION                             : ${API_VERSION}")
message("  API_FLAGS                               : ${API_FLAGS}")
message("  MFX_CONFIG_FILE                         : ${MFX_CONFIG_FILE}")
message("  See detailed per-component mediasdk configuration in the auto-generated file:")
message("    ${MSDK_CMAKE_BINARY_ROOT}/mfx_features.h")
message("Cmake:")
message("  CMAKE_VERSION                           : ${CMAKE_VERSION}")
message("  CMAKE_GENERATOR                         : ${CMAKE_GENERATOR}")
message("  CMAKE_BUILD_TOOL                        : ${CMAKE_BUILD_TOOL}")
message("Target:")
message("  CMAKE_SYSTEM_NAME                       : ${CMAKE_SYSTEM_NAME}")
message("  CMAKE_SYSTEM_VERSION                    : ${CMAKE_SYSTEM_VERSION}")
message("  CMAKE_SYSTEM_PROCESSOR                  : ${CMAKE_SYSTEM_PROCESSOR}")
message("General:")
message("  CMAKE_BUILD_TYPE                        : ${CMAKE_BUILD_TYPE}")
message("  CMAKE_TOOLCHAIN_FILE                    : ${CMAKE_TOOLCHAIN_FILE}")
message("  CMAKE_C_COMPILER                        : ${CMAKE_C_COMPILER}")
message("  CMAKE_CXX_COMPILER                      : ${CMAKE_CXX_COMPILER}")
if(CMAKE_SIZEOF_VOID_P EQUAL 8)
  message("  Building architecture                   : 64-bit")
else()
  message("  Building architecture                   : 32-bit")
endif()
message("Flags:")
message("  CMAKE_C_FLAGS                           : ${CMAKE_C_FLAGS}")
message("  CMAKE_CXX_FLAGS                         : ${CMAKE_CXX_FLAGS}")
message("Release flags:")
message("  CMAKE_C_FLAGS_RELEASE                   : ${CMAKE_C_FLAGS_RELEASE}")
message("  CMAKE_CXX_FLAGS_RELEASE                 : ${CMAKE_CXX_FLAGS_RELEASE}")
message("Debug flags:")
message("  CMAKE_C_FLAGS_DEBUG                     : ${CMAKE_C_FLAGS_DEBUG}")
message("  CMAKE_CXX_FLAGS_DEBUG                   : ${CMAKE_CXX_FLAGS_DEBUG}")
message("Install:")
message("  CMAKE_INSTALL_PREFIX                    : ${CMAKE_INSTALL_PREFIX}")
if (BUILD_TOOLS)
  message("  CMAKE_INSTALL_FULL_BINDIR               : ${CMAKE_INSTALL_FULL_BINDIR}")
endif()
message("  CMAKE_INSTALL_FULL_INCLUDEDIR           : ${CMAKE_INSTALL_FULL_INCLUDEDIR}")
message("  CMAKE_INSTALL_FULL_LIBDIR               : ${CMAKE_INSTALL_FULL_LIBDIR}")
message("  CMAKE_INSTALL_FULL_DATADIR              : ${CMAKE_INSTALL_FULL_DATADIR}")
message("Enable:")
message("  ENABLE_ITT                              : ${ENABLE_ITT}")
message("  ENABLE_TEXTLOG                          : ${ENABLE_TEXTLOG}")
message("  ENABLE_STAT                             : ${ENABLE_STAT}")
message("  ENABLE_PXP                              : ${MFX_ENABLE_PXP}")
message("Build:")
message("  BUILD_RUNTIME                           : ${BUILD_RUNTIME}")
message("  BUILD_TESTS                             : ${BUILD_TESTS}")
message("  BUILD_MOCK_TESTS                        : ${BUILD_MOCK_TESTS}")
message("  BUILD_TOOLS                             : ${BUILD_TOOLS}")
message("  BUILD_KERNELS                           : ${BUILD_KERNELS}")
message("*****************************************************************************")

include(sources_ext.cmake OPTIONAL)

=== _studio/mfx_lib/encode_hw/CMakeLists.txt ===
add_library(encode_hw STATIC)

include(functions.cmake)

if (MFX_ENABLE_H264_VIDEO_ENCODE)
  target_include_directories(encode_hw PUBLIC
    h264/include
  )

  set(AVC_VIDEO_ENCODE_SRC
    h264/include/mfx_h264_encode_hw.h
    h264/include/mfx_h264_encode_hw_utils.h
    h264/include/mfx_h264_enc_common_hw.h
    h264/include/mfx_h264_encode_interface.h
    h264/include/mfx_h264_encode_struct_vaapi.h
    h264/include/mfx_h264_encode_vaapi.h

    h264/src/mfx_h264_encode_hw.cpp
    h264/src/mfx_h264_encode_hw_utils.cpp
    h264/src/mfx_h264_encode_hw_utils_new.cpp
    h264/src/mfx_h264_enc_common_hw.cpp
    h264/src/mfx_h264_encode_factory.cpp
    h264/src/mfx_h264_encode_vaapi.cpp

  )

  source_group("avc" FILES ${AVC_VIDEO_ENCODE_SRC})
endif()

if (MFX_ENABLE_H265_VIDEO_ENCODE)
  target_include_directories(encode_hw PUBLIC
    hevc
    hevc/agnostic
    hevc/agnostic/base
    hevc/agnostic/g12
    hevc/linux
    hevc/linux/g9
    hevc/linux/g12
    hevc/linux/base
  )

    target_include_directories(encode_hw PUBLIC
      hevc/linux/xe_hpm
      hevc/linux/xe_lpm_plus
      hevc/linux/xe2
    )

  set(HEVC_VIDEO_ENCODE_SRC
    hevc/hevcehw_disp.h
    hevc/agnostic/hevcehw_base.h
    hevc/agnostic/hevcehw_block_queues.h
    hevc/agnostic/hevcehw_ddi.h
    hevc/agnostic/hevcehw_decl_blocks.h
    hevc/agnostic/hevcehw_utils.h
    hevc/agnostic/base/hevcehw_base_data.h
    hevc/agnostic/base/hevcehw_base_dirty_rect.h
    hevc/agnostic/base/hevcehw_base_encode_stats.h
    hevc/agnostic/base/hevcehw_base_encoded_frame_info.h
    hevc/agnostic/base/hevcehw_base_enctools.cpp
    hevc/agnostic/base/hevcehw_base_enctools.h
    hevc/agnostic/base/hevcehw_base_enctools_com.cpp
    hevc/agnostic/base/hevcehw_base_enctools_com.h
    hevc/agnostic/base/hevcehw_base_ext_brc.h
    hevc/agnostic/base/hevcehw_base_hdr_sei.h
    hevc/agnostic/base/hevcehw_base_hrd.h
    hevc/agnostic/base/hevcehw_base_iddi.h
    hevc/agnostic/base/hevcehw_base_iddi_packer.h
    hevc/agnostic/base/hevcehw_base_interlace.h
    hevc/agnostic/base/hevcehw_base_legacy.h
    hevc/agnostic/base/hevcehw_base_max_frame_size.h
    hevc/agnostic/base/hevcehw_base_packer.h
    hevc/agnostic/base/hevcehw_base_parser.h
    hevc/agnostic/base/hevcehw_base_query_impl_desc.h
    hevc/agnostic/base/hevcehw_base_roi.h
    hevc/agnostic/base/hevcehw_base_task.h
    hevc/agnostic/base/hevcehw_base_weighted_prediction.h
    hevc/agnostic/base/hevcehw_base_alloc.h
    hevc/agnostic/base/hevcehw_base_constraints.h
    hevc/agnostic/base/hevcehw_base_scc.h
    hevc/agnostic/base/hevcehw_base_sao.h
    hevc/agnostic/base/hevcehw_base_rext.h
    hevc/agnostic/base/hevcehw_base_extddi.h
    hevc/agnostic/base/hevcehw_base_caps.h
    hevc/agnostic/base/hevcehw_base_recon422.h
    hevc/agnostic/base/hevcehw_base_recon422_ext.h
    hevc/agnostic/g12/hevcehw_g12_caps.h
    hevc/agnostic/g12/hevcehw_g12_data.h

    hevc/linux/base/hevcehw_base_encoded_frame_info_lin.h
    hevc/linux/base/hevcehw_base_interlace_lin.h
    hevc/linux/base/hevcehw_base_lin.h
    hevc/linux/base/hevcehw_base_roi_lin.h
    hevc/linux/base/hevcehw_base_va_lin.h
    hevc/linux/base/hevcehw_base_va_packer_lin.h
    hevc/linux/base/hevcehw_base_enctools_qmatrix_lin.h
    hevc/linux/base/hevcehw_base_weighted_prediction_lin.h
    hevc/linux/base/hevcehw_base_max_frame_size_lin.h
    hevc/linux/base/hevcehw_base_dirty_rect_lin.h
    hevc/linux/base/hevcehw_base_rext_lin.h
    hevc/linux/base/hevcehw_base_scc_lin.h
    hevc/linux/base/hevcehw_base_qp_modulation_lin.h
    hevc/linux/base/hevcehw_base_caps_lin.h
    hevc/linux/g12/hevcehw_g12_caps_lin.h
    hevc/linux/g12/hevcehw_g12_lin.h

    hevc/hevcehw_disp.cpp
    hevc/agnostic/hevcehw_base.cpp
    hevc/agnostic/base/hevcehw_base_alloc.cpp
    hevc/agnostic/base/hevcehw_base_constraints.cpp
    hevc/agnostic/base/hevcehw_base_dirty_rect.cpp
    hevc/agnostic/base/hevcehw_base_encode_stats.cpp
    hevc/agnostic/base/hevcehw_base_encoded_frame_info.cpp
    hevc/agnostic/base/hevcehw_base_ext_brc.cpp
    hevc/agnostic/base/hevcehw_base_hdr_sei.cpp
    hevc/agnostic/base/hevcehw_base_hrd.cpp
    hevc/agnostic/base/hevcehw_base_interlace.cpp
    hevc/agnostic/base/hevcehw_base_impl.cpp
    hevc/agnostic/base/hevcehw_base_legacy.cpp
    hevc/agnostic/base/hevcehw_base_legacy_defaults.cpp
    hevc/agnostic/base/hevcehw_base_max_frame_size.cpp
    hevc/agnostic/base/hevcehw_base_packer.cpp
    hevc/agnostic/base/hevcehw_base_parser.cpp
    hevc/agnostic/base/hevcehw_base_recon_info.cpp
    hevc/agnostic/base/hevcehw_base_query_impl_desc.cpp
    hevc/agnostic/base/hevcehw_base_roi.cpp
    hevc/agnostic/base/hevcehw_base_task.cpp
    hevc/agnostic/base/hevcehw_base_weighted_prediction.cpp
    hevc/agnostic/base/hevcehw_base_rext.cpp
    hevc/agnostic/base/hevcehw_base_scc.cpp
    hevc/agnostic/base/hevcehw_base_extddi.cpp
    hevc/agnostic/base/hevcehw_base_caps.cpp
    hevc/agnostic/g12/hevcehw_g12_caps.cpp

    hevc/linux/base/hevcehw_base_interlace_lin.cpp
    hevc/linux/base/hevcehw_base_lin.cpp
    hevc/linux/base/hevcehw_base_roi_lin.cpp
    hevc/linux/base/hevcehw_base_va_lin.cpp
    hevc/linux/base/hevcehw_base_va_packer_lin.cpp
    hevc/linux/base/hevcehw_base_weighted_prediction_lin.cpp
    hevc/linux/base/hevcehw_base_enctools_qmatrix_lin.cpp
    hevc/linux/base/hevcehw_base_max_frame_size_lin.cpp
    hevc/linux/base/hevcehw_base_dirty_rect_lin.cpp
    hevc/linux/base/hevcehw_base_rext_lin.cpp
    hevc/linux/base/hevcehw_base_qp_modulation_lin.cpp
    hevc/linux/g12/hevcehw_g12_lin.cpp
  )

    set(HEVC_VIDEO_ENCODE_SRC
      ${HEVC_VIDEO_ENCODE_SRC}
      hevc/linux/xe_hpm/hevcehw_xe_hpm_lin.h
      hevc/linux/xe_hpm/hevcehw_xe_hpm_lin.cpp
      hevc/linux/xe_lpm_plus/hevcehw_xe_lpm_plus_lin.h
      hevc/linux/xe_lpm_plus/hevcehw_xe_lpm_plus_lin.cpp
      hevc/linux/xe2/hevcehw_xe2_lin.h
      hevc/linux/xe2/hevcehw_xe2_lin.cpp
    )

  custom_source_group("hevc" ${HEVC_VIDEO_ENCODE_SRC})
endif()

if (MFX_ENABLE_AV1_VIDEO_ENCODE)
  target_include_directories(encode_hw PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/linux
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/linux/base
  )

    target_include_directories(encode_hw PUBLIC
      ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/Xe_HPM
      ${CMAKE_CURRENT_SOURCE_DIR}/av1/linux/Xe_HPM
      ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/Xe_LPM_plus
      ${CMAKE_CURRENT_SOURCE_DIR}/av1/linux/Xe_LPM_plus
      ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/Xe2
      ${CMAKE_CURRENT_SOURCE_DIR}/av1/linux/Xe2
    )

  set(AV1_VIDEO_ENCODE_SRC
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/av1ehw_disp.h
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/av1eimplbase.h
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/av1ehw_disp.cpp

    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/av1ehw_base.h
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/av1ehw_block_queues.h
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/av1ehw_ddi.h
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/av1ehw_decl_blocks.h
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/av1ehw_utils.h
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/av1ehw_base.cpp

    ${CMAKE_CURRENT_SOURCE_DIR}/av1/linux/av1ehw_struct_vaapi.h

    ${CMAKE_CURRENT_SOURCE_DIR}/av1/linux/base/av1ehw_base_lin.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/linux/base/av1ehw_base_lin.h
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/linux/base/av1ehw_base_va_lin.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/linux/base/av1ehw_base_va_lin.h
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/linux/base/av1ehw_base_va_packer_lin.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/linux/base/av1ehw_base_va_packer_lin.h
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/linux/base/av1ehw_base_qmatrix_lin.h
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/linux/base/av1ehw_base_max_frame_size_lin.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/linux/base/av1ehw_base_max_frame_size_lin.h

    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_alloc.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_alloc.h
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_constraints.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_constraints.h
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_data.h

    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_qmatrix.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_qmatrix.h
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_general.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_general.h
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_general_defaults.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_iddi.h
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_iddi_packer.h
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_impl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_impl.h
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_interpo_filter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_interpo_filter.h
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_packer.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_packer.h
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_query_impl_desc.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_query_impl_desc.h
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_segmentation.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_segmentation.h
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_task.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_task.h
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_tile.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_tile.h
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_encoded_frame_info.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_encoded_frame_info.h
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_max_frame_size.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_max_frame_size.h
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_enctools.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_enctools.h
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_hdr.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_hdr.h
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_enctools_com.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_enctools_com.h
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_scc.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_scc.h
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_cdef.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/base/av1ehw_base_cdef.h
  )

    set(AV1_VIDEO_ENCODE_SRC
      ${AV1_VIDEO_ENCODE_SRC}
      ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/Xe_HPM/av1ehw_xe_hpm.h
      ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/Xe_HPM/av1ehw_xe_hpm_segmentation.cpp
      ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/Xe_HPM/av1ehw_xe_hpm_segmentation.h

      ${CMAKE_CURRENT_SOURCE_DIR}/av1/linux/Xe_HPM/av1ehw_xe_hpm_lin.cpp
      ${CMAKE_CURRENT_SOURCE_DIR}/av1/linux/Xe_HPM/av1ehw_xe_hpm_lin.h

      ${CMAKE_CURRENT_SOURCE_DIR}/av1/linux/Xe_LPM_plus/av1ehw_xe_lpm_plus_lin.cpp
      ${CMAKE_CURRENT_SOURCE_DIR}/av1/linux/Xe_LPM_plus/av1ehw_xe_lpm_plus_lin.h

      ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/Xe_LPM_plus/av1ehw_xe_lpm_plus.h

      ${CMAKE_CURRENT_SOURCE_DIR}/av1/linux/Xe2/av1ehw_xe2_lin.cpp
      ${CMAKE_CURRENT_SOURCE_DIR}/av1/linux/Xe2/av1ehw_xe2_lin.h

      ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/Xe2/av1ehw_xe2_scc.cpp
      ${CMAKE_CURRENT_SOURCE_DIR}/av1/agnostic/Xe2/av1ehw_xe2_scc.h
    )

  custom_source_group("av1" ${AV1_VIDEO_ENCODE_SRC})
endif()

if (MFX_ENABLE_MJPEG_VIDEO_ENCODE)

=== _studio/mfx_lib/ext/CMakeLists.txt ===
# Copyright (c) 2018-2021 Intel Corporation
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

add_subdirectory(cmrt_cross_platform)
add_subdirectory(asc)

add_library(mfx_ext STATIC)

if(MFX_ENABLE_KERNELS)

  set( MSDK_GENX_ROOT ${MSDK_LIB_ROOT}/ext/genx )

  if (BUILD_KERNELS)
    # Here we define build steps to generate c-array binary kernels. If you
    # don't use BUILD_KERNELS options these kernels will just be used from
    # pre-built form. If you will regenerate kernels you may notice the
    # difference from the per-built kernels in git-diff.

    # Helper application to generate c-array data representation of .isa binary
    # kernels.
    add_executable(embed_isa ${MSDK_GENX_ROOT}/tools/embed_isa.c)
    set_target_properties(embed_isa PROPERTIES
      RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

    # Generates CM kernel suitable for usage in C/C++ application sources
    #   ${src} - input CM kernel source file
    #   ${genx} - platform generation level
    #   ${out_dir} - directory to generate output
    # Generated outputs for ${src}=path/file.cpp, ${genx}=gen9:
    #   ${out_dir}/file_gen9_isa.h
    #   ${out_dir}/file_gen9_isa.cpp
    function(add_cmc_target src genx out_dir)
      get_filename_component(tgt ${src} NAME_WE)
      add_custom_command(
        OUTPUT ${tgt}_${genx}.isa
        DEPENDS embed_isa ${src}
        COMMAND ${CMC}
          -c -Qxcm -Qxcm_release -Qxcm_print_asm_count
          -menableiga -mCM_init_global -mCM_printregusage
          -Dtarget_${genx} -Qxcm_jit_target=${genx}
          ${src} -o ${tgt}_${genx}.isa)

      add_custom_command(
        OUTPUT ${tgt}_${genx}_isa.cpp ${tgt}_${genx}_isa.h
        DEPENDS embed_isa ${tgt}_${genx}.isa
        COMMAND embed_isa ${tgt}_${genx}.isa)
      add_custom_command(
        OUTPUT ${out_dir}/${tgt}_${genx}_isa.h ${out_dir}/${tgt}_${genx}_isa.cpp
        DEPENDS ${tgt}_${genx}_isa.cpp ${tgt}_${genx}_isa.h
        COMMAND ${CMAKE_COMMAND} -E copy ${tgt}_${genx}_isa.h ${out_dir}
        COMMAND ${CMAKE_COMMAND} -E copy ${tgt}_${genx}_isa.cpp ${out_dir})
    endfunction()
  endif()

  ### ASC
  if( MFX_ENABLE_ASC )
    if(BUILD_KERNELS)
      foreach(platform gen12lp)
        add_cmc_target(${MSDK_GENX_ROOT}/asc/src/genx_scd.cpp ${platform} ${MSDK_GENX_ROOT}/asc/isa)
      endforeach()
    endif()

    set( prefix ${MSDK_GENX_ROOT}/asc/isa )
    list( APPEND genx_sources
      ${prefix}/genx_scd_gen12lp_isa.cpp
    )
    list( APPEND genx_include_dirs
      ${prefix}
    )
  endif()

  ### copy
  if(BUILD_KERNELS)
    foreach(platform gen12lp)
      add_cmc_target(${MSDK_GENX_ROOT}/copy_kernels/src/genx_copy_kernel.cpp ${platform} ${MSDK_GENX_ROOT}/copy_kernels/isa)
    endforeach()
  endif()

  set( prefix ${MSDK_GENX_ROOT}/copy_kernels/isa )
  list( APPEND genx_sources
    ${prefix}/genx_copy_kernel_gen12lp_isa.cpp
  )
  list( APPEND genx_include_dirs
    ${prefix}
  )

  ### field copy
  if(BUILD_KERNELS)
    foreach(platform gen12lp)
      add_cmc_target(${MSDK_GENX_ROOT}/field_copy/src/genx_fcopy.cpp ${platform} ${MSDK_GENX_ROOT}/field_copy/isa)
    endforeach()
  endif()

  set( prefix ${MSDK_GENX_ROOT}/field_copy/isa )
  list( APPEND genx_sources
    ${prefix}/genx_fcopy_gen12lp_isa.cpp
  )
  list( APPEND genx_include_dirs
    ${prefix}
  )

  ### h264_encode
  if(MFX_ENABLE_H264_VIDEO_ENCODE)
    if(BUILD_KERNELS)
      foreach(platform gen12lp)
        add_cmc_target(${MSDK_GENX_ROOT}/h264_encode/src/genx_histogram.cpp ${platform} ${MSDK_GENX_ROOT}/h264_encode/isa)
        add_cmc_target(${MSDK_GENX_ROOT}/h264_encode/src/genx_simple_me.cpp ${platform} ${MSDK_GENX_ROOT}/h264_encode/isa)
      endforeach()
    endif()

    set( prefix ${MSDK_GENX_ROOT}/h264_encode/isa )
    list( APPEND genx_sources
      ${MSDK_GENX_ROOT}/h264_encode/src/genx_simple_me_proto.cpp
      ${prefix}/genx_simple_me_gen12lp_isa.cpp
      ${prefix}/genx_histogram_gen12lp_isa.cpp
    )
    list( APPEND genx_include_dirs
      ${prefix}
    )

  endif()

  ### MCTF
  if(MFX_ENABLE_MCTF)
    if(BUILD_KERNELS)
      foreach(platform gen12lp)
        add_cmc_target(${MSDK_GENX_ROOT}/mctf/src/genx_me.cpp ${platform} ${MSDK_GENX_ROOT}/mctf/isa)
        add_cmc_target(${MSDK_GENX_ROOT}/mctf/src/genx_mc.cpp ${platform} ${MSDK_GENX_ROOT}/mctf/isa)
        add_cmc_target(${MSDK_GENX_ROOT}/mctf/src/genx_sd.cpp ${platform} ${MSDK_GENX_ROOT}/mctf/isa)
      endforeach()
    endif()

    set( prefix ${MSDK_GENX_ROOT}/mctf/isa )
    list( APPEND genx_sources
      ${prefix}/genx_mc_gen12lp_isa.cpp
      ${prefix}/genx_me_gen12lp_isa.cpp
      ${prefix}/genx_sd_gen12lp_isa.cpp
    )
    list( APPEND mctf_package
      mctf_package/mctf/src/mctf_common.cpp
      mctf_package/mctf/include/mctf_common.h
    )
    list( APPEND genx_include_dirs
      ${prefix}
    )
    list ( APPEND mctf_include_dir
      mctf_package/mctf/include
    )
  endif()

  source_group("genx" FILES ${genx_sources})
  source_group("mctf_hw" FILES ${mctf_package})

  target_include_directories(mfx_ext
    PUBLIC
      ${genx_include_dirs}
      ${mctf_include_dir}
      ${VULKAN_INCLUDE}
  )

  target_sources(mfx_ext PRIVATE
    ${genx_sources}
    ${mctf_package}
  )

  if (MFX_ENABLE_H264_VIDEO_ENCODE)
    target_include_directories(mfx_ext PUBLIC
      h264/include
      ${MSDK_UMC_ROOT}/codec/brc/include
      ${MSDK_LIB_ROOT}/encode_hw/h264/include
    )
    set(avc_video_encode_src
      h264/include/mfx_h264_encode_cm.h
      h264/include/mfx_h264_encode_cm_defs.h
      h264/src/mfx_h264_encode_cm.cpp
    )

    source_group("avce" FILES ${avc_video_encode_src})

    target_sources(mfx_ext PRIVATE
      ${avc_video_encode_src}
    )
  endif()
endif()

if (MFX_ENABLE_MPEG2_VIDEO_ENCODE)
  target_include_directories(mfx_ext PUBLIC
    mpeg2/include
    ${MSDK_UMC_ROOT}/codec/brc/include
    ${MSDK_LIB_ROOT}/shared/include
    ${MSDK_STUDIO_ROOT}/shared/enctools/include
  )

  set(mpeg2_video_encode_src
    mpeg2/include/mfx_mpeg2_encode_debug_hw.h
    mpeg2/include/mfx_mpeg2_encode_full_hw.h
    mpeg2/include/mfx_mpeg2_encode_hw.h
    mpeg2/include/mfx_mpeg2_encode_utils_hw.h
    mpeg2/include/mfx_mpeg2_enc_common.h
    mpeg2/include/mfx_mpeg2_enc_common_hw.h
    mpeg2/include/mfx_mpeg2_encode_interface.h
    mpeg2/include/mfx_mpeg2_encode_vaapi.h

    mpeg2/src/mfx_mpeg2_encode_debug_hw.cpp
    mpeg2/src/mfx_mpeg2_encode_full_hw.cpp
    mpeg2/src/mfx_mpeg2_encode_hw.cpp
    mpeg2/src/mfx_mpeg2_encode_utils_hw.cpp
    mpeg2/src/mfx_mpeg2_encode_vaapi.cpp
    mpeg2/src/mfx_mpeg2_encode_factory.cpp
    mpeg2/src/mfx_mpeg2_enc_common_hw.cpp

  )

  source_group("mpeg2e" FILES ${mpeg2_video_encode_src})

  target_sources(mfx_ext PRIVATE
    ${mpeg2_video_encode_src}
  )
endif()

target_link_libraries(mfx_ext
  PUBLIC
    mfx_static_lib
    asc_ext
    cmrt_cross_platform_hw
  PRIVATE
    bitrate_control
)

include(sources_ext.cmake OPTIONAL)

=== _studio/shared/IntelMediaSDK/CMakeLists.txt ===
if (NOT CMAKE_SYSTEM_NAME MATCHES Windows)
    return()
endif()

cmake_minimum_required(VERSION 3.5)
project(IntelMediaSDK)
set(DLL_NAME IntelMediaSDK)

# MediaEtwSetLinkerFlags: apply linker flags for given configuration
# linkerFlags: linker specific options
# linkerTarget: optional parameter - apply linker flags for specfied target
macro (MediaEtwSetLinkerFlags linkerFlags linkerTarget)
    foreach (opt ${linkerFlags})
        if ("${linkerTarget}" STREQUAL "")
            set (CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${opt}")
            set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${opt}")
        else()
            set (CMAKE_SHARED_LINKER_FLAGS_${linkerTarget} "${CMAKE_SHARED_LINKER_FLAGS_${linkerTarget}} ${opt}")
            set (CMAKE_EXE_LINKER_FLAGS_${linkerTarget} "${CMAKE_SHARED_LINKER_FLAGS_${linkerTarget}} ${opt}")
        endif()
    endforeach()
endmacro()

set(SOURCES_
    ${MSDK_STUDIO_ROOT}/shared/mfx_trace/IntelMediaSDK.man
    )

source_group("Resource Files" FILES
    ${MSDK_STUDIO_ROOT}/shared/mfx_trace/IntelMediaSDK.man
    ${CMAKE_BINARY_DIR}/IntelMediaSDK.rc
    )

# set compiler options
include(sources_ext.cmake)	

SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /D_UNICODE /DUNICODE")
	
set (CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

add_library(${DLL_NAME} SHARED ${SOURCES_} ${CMAKE_BINARY_DIR}/IntelMediaSDK.rc)

set_target_properties(${DLL_NAME} PROPERTIES OUTPUT_NAME IntelMediaSDK)

add_custom_command(
    OUTPUT ${CMAKE_BINARY_DIR}/IntelMediaSDK.rc 
    COMMENT "Running mc.exe to compile Media ETW manifest"
    COMMAND mc -h ${CMAKE_BINARY_DIR} -r ${CMAKE_BINARY_DIR} -z IntelMediaSDK -um ${MSDK_STUDIO_ROOT}/shared/mfx_trace/IntelMediaSDK.man
)

=== _studio/shared/asc/CMakeLists.txt ===


add_library(asc_sse4 OBJECT
    include/asc_sse4_impl.h
    include/motion_estimation_engine.h
    src/asc_sse4_impl.cpp
    src/motion_estimation_engine.cpp
)
set_property(TARGET asc_sse4 PROPERTY FOLDER "optimization/asc")

target_include_directories(asc_sse4 PRIVATE include)

target_link_libraries(asc_sse4 PRIVATE 
    mfx_require_sse4_properties 
    mfx_static_lib
    mfx_sdl_properties)

#=====================================================================

add_library(asc_avx2 OBJECT
    include/asc_avx2_impl.h
    src/asc_avx2_impl.cpp
    )
set_property(TARGET asc_avx2 PROPERTY FOLDER "optimization/asc")

target_include_directories(asc_avx2 PRIVATE include)

target_link_libraries(asc_avx2 PRIVATE
    mfx_require_avx2_properties
    mfx_static_lib
    mfx_sdl_properties)

#=====================================================================

list( APPEND sources

    include/asc_c_impl.h
    include/asc_common_impl.h
    include/asc_cpu_dispatcher.h
    include/asc_defs.h
    include/asc.h
    include/asc_structures.h
    include/cpu_detect.h
    include/iofunctions.h
    include/me_asc.h
    include/tree.h

    src/asc.cpp
    src/asc_c_impl.cpp
    src/iofunctions.cpp
    src/tree.cpp

    $<TARGET_OBJECTS:asc_sse4>
    $<TARGET_OBJECTS:asc_avx2>
  )

add_library(asc STATIC ${sources})

target_include_directories(asc PUBLIC include)

target_link_libraries(asc
  PUBLIC
    mfx_static_lib
  PRIVATE
    mfx_sdl_properties
    umc
  )

=== _studio/shared/umc/core/umc/CMakeLists.txt ===
add_library(umc STATIC)
set_property(TARGET umc PROPERTY FOLDER "umc")

target_sources(umc
  PRIVATE
    include/umc_base_codec.h
    include/umc_base_color_space_converter.h
    include/umc_defs.h
    include/umc_dynamic_cast.h
    include/umc_frame_allocator.h
    include/umc_frame_data.h
    include/umc_media_data.h
    include/umc_memory_allocator.h
    include/umc_structures.h
    include/umc_va_base.h
    include/umc_video_data.h
    include/umc_video_decoder.h
    include/umc_video_encoder.h

    src/umc_base_codec.cpp
    src/umc_frame_data.cpp
    src/umc_media_data.cpp
    src/umc_va_base.cpp
    src/umc_video_data.cpp
    src/umc_video_decoder.cpp
    src/umc_video_encoder.cpp
  )

target_include_directories(umc
  PUBLIC
    include

    ${MSDK_STUDIO_ROOT}/shared/mfx_logging/include
  )

target_link_libraries(umc
  PUBLIC
    mfx_static_lib
    vm
    vm_plus
    ${IPP_LIBS}
  PRIVATE
    mfx_sdl_properties
  )

include(sources_ext.cmake OPTIONAL)

=== debian/changelog ===
onevpl-intel-gpu (25.1.4-1) unstable; urgency=medium

  * New upstream release.
  * patches: Add more BMG pci-id's. (LP: #2104011)

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 24 Mar 2025 16:30:12 +0200

=== debian/control ===
Source: onevpl-intel-gpu
Section: graphics
Priority: optional
Maintainer: Timo Aaltonen <tjaalton@debian.org>
Build-Depends: debhelper-compat (= 13),
 cmake,
 libdrm-dev,
 libva-dev,
 libvpl-dev,
 pkgconf,
Standards-Version: 4.6.0
Homepage: https://github.com/intel/vpl-gpu-rt
Vcs-Browser: https://salsa.debian.org/debian/onevpl-intel-gpu
Vcs-Git: https://salsa.debian.org/debian/onevpl-intel-gpu.git
Rules-Requires-Root: no

Package: libmfx-gen1.2
Architecture: amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Intel VPL GPU Runtime -- shared library
 Intel Video Processing Library GPU Runtime is a Runtime implementation of
 Intel VPL API for Intel Gen GPUs. Runtime provides access to
 hardware-accelerated video decode, encode and filtering.
 .
 Supported video encoders: HEVC, AVC, MPEG-2, JPEG, VP9  
 Supported video decoders: HEVC, AVC, VP8, VP9, MPEG-2, VC1, JPEG, AV1, VVC
 Supported video pre-processing filters: Color Conversion, Deinterlace, Denoise,
 Resize, Rotate, Composition  
 .
 This package includes the shared library.

Package: libmfx-gen-dev
Architecture: amd64
Depends: ${misc:Depends},
 libmfx-gen1.2 (= ${binary:Version})
Description: Intel VPL GPU Runtime -- development files
 Intel Video Processing Library GPU Runtime is a Runtime implementation of
 Intel VPL API for Intel Gen GPUs. Runtime provides access to
 hardware-accelerated video decode, encode and filtering.
 .
 Supported video encoders: HEVC, AVC, MPEG-2, JPEG, VP9  
 Supported video decoders: HEVC, AVC, VP8, VP9, MPEG-2, VC1, JPEG, AV1, VVC
 Supported video pre-processing filters: Color Conversion, Deinterlace, Denoise,
 Resize, Rotate, Composition  
 .
 This package includes files for development.
